package org.freehep.jas;

import java.awt.Component;
import java.util.Iterator;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;
import org.freehep.application.mdi.PageManager;
import org.freehep.application.studio.Studio;
import org.openide.util.Lookup.Result;
import org.openide.util.Lookup.Template;
import org.openide.util.Lookup.Item;

/**
 *
 * @author tonyj
 */
class GeneralPreferences extends JPanel
{
   
   /** Creates new form GeneralPreferences */
   GeneralPreferences(Studio app)
   {
      this.app = app;
      initComponents();
   }
   
   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */
   private void initComponents()//GEN-BEGIN:initComponents
   {
      java.awt.GridBagConstraints gridBagConstraints;

      jCheckBox2 = new javax.swing.JCheckBox();
      jCheckBox3 = new javax.swing.JCheckBox();
      jCheckBox4 = new javax.swing.JCheckBox();
      jLabel1 = new javax.swing.JLabel();
      jComboBox1 = new javax.swing.JComboBox();
      UIManager.LookAndFeelInfo info[] = UIManager.getInstalledLookAndFeels();
      String currentName = UIManager.getLookAndFeel().getName();
      for (int i=0; i<info.length; i++)
      {
         jComboBox1.addItem(info[i]);
         if (currentName.equals(info[i].getName())) jComboBox1.setSelectedIndex(i);
      }
      jLabel2 = new javax.swing.JLabel();
      jComboBox2 = new javax.swing.JComboBox();
      PageManager pm = app.getPageManager();
      Template template = new Template(PageManager.class);
      Result result = app.getLookup().lookup(template);
      for (Iterator i = result.allItems().iterator(); i.hasNext(); )
      {
         Item item = (Item) i.next();
         jComboBox2.addItem(item.getId());
         if (item.getInstance() == pm) jComboBox2.setSelectedItem(item.getId());
      }

      setLayout(new java.awt.GridBagLayout());

      setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
      jCheckBox2.setSelected(true);
      jCheckBox2.setText("Show Memory Usage");
      jCheckBox2.setEnabled(false);
      gridBagConstraints = new java.awt.GridBagConstraints();
      gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      add(jCheckBox2, gridBagConstraints);

      jCheckBox3.setSelected(app.getShowToolBar());
      jCheckBox3.setText("Show Tool Bar");
      gridBagConstraints = new java.awt.GridBagConstraints();
      gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      add(jCheckBox3, gridBagConstraints);

      jCheckBox4.setSelected(app.getShowStatusBar());
      jCheckBox4.setText("Show Status Bar");
      gridBagConstraints = new java.awt.GridBagConstraints();
      gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      add(jCheckBox4, gridBagConstraints);

      jLabel1.setLabelFor(jComboBox1);
      jLabel1.setText("Look and Feel");
      gridBagConstraints = new java.awt.GridBagConstraints();
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 6);
      add(jLabel1, gridBagConstraints);

      jComboBox1.setRenderer(new LAFRenderer());
      gridBagConstraints = new java.awt.GridBagConstraints();
      gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      gridBagConstraints.weightx = 1.0;
      add(jComboBox1, gridBagConstraints);

      jLabel2.setLabelFor(jComboBox2);
      jLabel2.setText("Window Manager");
      gridBagConstraints = new java.awt.GridBagConstraints();
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 6);
      add(jLabel2, gridBagConstraints);

      gridBagConstraints = new java.awt.GridBagConstraints();
      gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
      gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
      gridBagConstraints.weightx = 1.0;
      add(jComboBox2, gridBagConstraints);

   }//GEN-END:initComponents
   boolean apply()
   {
         LookAndFeelInfo info = (LookAndFeelInfo) jComboBox1.getSelectedItem();
         app.setLookAndFeel(info.getClassName());

         String managerName = jComboBox2.getSelectedItem().toString();
         Template template = new Template(PageManager.class,managerName,null);
         Result result = app.getLookup().lookup(template);
         PageManager manager = (PageManager) result.allInstances().iterator().next();
         app.setPageManager(manager);
         app.getUserProperties().setProperty("pageManagerName",managerName);
         
         app.setShowToolBar(jCheckBox3.isSelected());
         app.setShowStatusBar(jCheckBox4.isSelected());
         return true;
   }
   
   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JCheckBox jCheckBox2;
   private javax.swing.JCheckBox jCheckBox3;
   private javax.swing.JCheckBox jCheckBox4;
   private javax.swing.JComboBox jComboBox1;
   private javax.swing.JComboBox jComboBox2;
   private javax.swing.JLabel jLabel1;
   private javax.swing.JLabel jLabel2;
   // End of variables declaration//GEN-END:variables
   private Studio app;
   private static class LAFRenderer extends DefaultListCellRenderer
   {
      public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
      {         
         return super.getListCellRendererComponent(list, ((LookAndFeelInfo) value).getName(), index, isSelected, cellHasFocus);
      }
   }
}